blob: 5c6e6d7a5ddfd3dc5d1a3c40d39bc0f86f335d09 [file] [log] [blame]
Jason Kusumabe998f42015-09-03 15:53:13 -07001#!/bin/bash
2
Amin Hassani13520932017-07-26 11:26:05 -07003#
4# Copyright (C) 2015 The Android Open Source Project
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10# http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
Jason Kusumabe998f42015-09-03 15:53:13 -070018
19# Script to generate a Brillo update for use by the update engine.
20#
21# usage: brillo_update_payload COMMAND [ARGS]
22# The following commands are supported:
23# generate generate an unsigned payload
24# hash generate a payload or metadata hash
25# sign generate a signed payload
Alex Deymo98e691c2016-02-04 21:05:45 -080026# properties generate a properties file from a payload
Amin Hassani13520932017-07-26 11:26:05 -070027# verify verify a payload by recreating a target image.
Tudor Brindusb432db82018-06-29 13:13:27 -070028# check verify a payload using paycheck (static testing)
Jason Kusumabe998f42015-09-03 15:53:13 -070029#
30# Generate command arguments:
Jason Kusuma9a4cae22015-10-08 18:17:57 -070031# --payload generated unsigned payload output file
32# --source_image if defined, generate a delta payload from the specified
33# image to the target_image
34# --target_image the target image that should be sent to clients
Amin Hassani13520932017-07-26 11:26:05 -070035# --metadata_size_file if defined, generate a file containing the size of the
36# payload metadata in bytes to the specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070037#
38# Hash command arguments:
39# --unsigned_payload the input unsigned payload to generate the hash from
40# --signature_size signature sizes in bytes in the following format:
Alex Deymo89ff9e32015-09-15 19:29:01 -070041# "size1:size2[:...]"
Jason Kusumabe998f42015-09-03 15:53:13 -070042# --payload_hash_file if defined, generate a payload hash and output to the
43# specified file
44# --metadata_hash_file if defined, generate a metadata hash and output to the
45# specified file
46#
47# Sign command arguments:
Alex Deymo89ff9e32015-09-15 19:29:01 -070048# --unsigned_payload the input unsigned payload to insert the signatures
49# --payload the output signed payload
50# --signature_size signature sizes in bytes in the following format:
51# "size1:size2[:...]"
52# --payload_signature_file the payload signature files in the following
53# format:
54# "payload_signature1:payload_signature2[:...]"
55# --metadata_signature_file the metadata signature files in the following
56# format:
57# "metadata_signature1:metadata_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -070058# --metadata_size_file if defined, generate a file containing the size of
59# the signed payload metadata in bytes to the
60# specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070061# Note that the number of signature sizes and payload signatures have to match.
Alex Deymo98e691c2016-02-04 21:05:45 -080062#
63# Properties command arguments:
64# --payload the input signed or unsigned payload
65# --properties_file the output path where to write the properties, or
66# '-' for stdout.
Amin Hassani13520932017-07-26 11:26:05 -070067# Verify command arguments:
68# --payload payload input file
69# --source_image verify payload to the specified source image.
70# --target_image the target image to verify upon.
Tudor Brindusb432db82018-06-29 13:13:27 -070071#
72# Check command arguments:
73# Symmetrical with the verify command.
Alex Deymo98e691c2016-02-04 21:05:45 -080074
Jason Kusumabe998f42015-09-03 15:53:13 -070075
Alex Deymo61e1fa82016-01-19 15:16:34 -080076# Exit codes:
77EX_UNSUPPORTED_DELTA=100
78
Jason Kusumaf514c542015-11-05 18:43:45 -080079warn() {
80 echo "brillo_update_payload: warning: $*" >&2
81}
82
Gilad Arnold957ce122015-10-14 16:02:55 -070083die() {
84 echo "brillo_update_payload: error: $*" >&2
85 exit 1
Jason Kusumabe998f42015-09-03 15:53:13 -070086}
87
Gilad Arnold957ce122015-10-14 16:02:55 -070088# Loads shflags. We first look at the default install location; then look for
Amin Hassani2a14d412018-05-31 13:01:09 -070089# crosutils (chroot); finally check our own directory.
Gilad Arnold957ce122015-10-14 16:02:55 -070090load_shflags() {
91 local my_dir="$(dirname "$(readlink -f "$0")")"
92 local path
93 for path in /usr/share/misc {/usr/lib/crosutils,"${my_dir}"}/lib/shflags; do
94 if [[ -r "${path}/shflags" ]]; then
95 . "${path}/shflags" || die "Could not load ${path}/shflags."
96 return
97 fi
98 done
99 die "Could not find shflags."
100}
101
102load_shflags
Jason Kusumabe998f42015-09-03 15:53:13 -0700103
Alex Deymoc64ffd52015-09-25 18:10:07 -0700104HELP_GENERATE="generate: Generate an unsigned update payload."
105HELP_HASH="hash: Generate the hashes of the unsigned payload and metadata used \
106for signing."
107HELP_SIGN="sign: Insert the signatures into the unsigned payload."
Alex Deymo98e691c2016-02-04 21:05:45 -0800108HELP_PROPERTIES="properties: Extract payload properties to a file."
Tudor Brindusb432db82018-06-29 13:13:27 -0700109HELP_VERIFY="verify: Verify a (signed) update payload using delta_generator."
110HELP_CHECK="check: Check a (signed) update payload using paycheck (static \
111testing)."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700112
113usage() {
114 echo "Supported commands:"
115 echo
116 echo "${HELP_GENERATE}"
117 echo "${HELP_HASH}"
118 echo "${HELP_SIGN}"
Alex Deymo98e691c2016-02-04 21:05:45 -0800119 echo "${HELP_PROPERTIES}"
Amin Hassani13520932017-07-26 11:26:05 -0700120 echo "${HELP_VERIFY}"
Tudor Brindusb432db82018-06-29 13:13:27 -0700121 echo "${HELP_CHECK}"
Alex Deymoc64ffd52015-09-25 18:10:07 -0700122 echo
123 echo "Use: \"$0 <command> --help\" for more options."
124}
125
126# Check that a command is specified.
Jason Kusumabe998f42015-09-03 15:53:13 -0700127if [[ $# -lt 1 ]]; then
Tudor Brindusb432db82018-06-29 13:13:27 -0700128 echo "Please specify a command [generate|hash|sign|properties|verify|check]"
Jason Kusumabe998f42015-09-03 15:53:13 -0700129 exit 1
130fi
131
Alex Deymoc64ffd52015-09-25 18:10:07 -0700132# Parse command.
133COMMAND="${1:-}"
134shift
135
136case "${COMMAND}" in
137 generate)
138 FLAGS_HELP="${HELP_GENERATE}"
139 ;;
140
141 hash)
142 FLAGS_HELP="${HELP_HASH}"
143 ;;
144
145 sign)
146 FLAGS_HELP="${HELP_SIGN}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700147 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800148
149 properties)
150 FLAGS_HELP="${HELP_PROPERTIES}"
151 ;;
Amin Hassani13520932017-07-26 11:26:05 -0700152
153 verify)
154 FLAGS_HELP="${HELP_VERIFY}"
155 ;;
156
Tudor Brindusb432db82018-06-29 13:13:27 -0700157 check)
158 FLAGS_HELP="${HELP_CHECK}"
159 ;;
160
Jason Kusumabe998f42015-09-03 15:53:13 -0700161 *)
Alex Deymoc64ffd52015-09-25 18:10:07 -0700162 echo "Unrecognized command: \"${COMMAND}\"" >&2
163 usage >&2
Jason Kusumabe998f42015-09-03 15:53:13 -0700164 exit 1
165 ;;
166esac
167
Jason Kusumabe998f42015-09-03 15:53:13 -0700168# Flags
Alex Deymoc64ffd52015-09-25 18:10:07 -0700169FLAGS_HELP="Usage: $0 ${COMMAND} [flags]
170${FLAGS_HELP}"
171
172if [[ "${COMMAND}" == "generate" ]]; then
173 DEFINE_string payload "" \
174 "Path to output the generated unsigned payload file."
175 DEFINE_string target_image "" \
176 "Path to the target image that should be sent to clients."
177 DEFINE_string source_image "" \
178 "Optional: Path to a source image. If specified, this makes a delta update."
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700179 DEFINE_string metadata_size_file "" \
180 "Optional: Path to output metadata size."
Sen Jiang8e768e92017-06-28 17:13:19 -0700181 DEFINE_string max_timestamp "" \
182 "Optional: The maximum unix timestamp of the OS allowed to apply this \
183payload, should be set to a number higher than the build timestamp of the \
184system running on the device, 0 if not specified."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700185fi
186if [[ "${COMMAND}" == "hash" || "${COMMAND}" == "sign" ]]; then
187 DEFINE_string unsigned_payload "" "Path to the input unsigned payload."
188 DEFINE_string signature_size "" \
189 "Signature sizes in bytes in the following format: size1:size2[:...]"
190fi
191if [[ "${COMMAND}" == "hash" ]]; then
192 DEFINE_string metadata_hash_file "" \
193 "Optional: Path to output metadata hash file."
194 DEFINE_string payload_hash_file "" \
195 "Optional: Path to output payload hash file."
196fi
197if [[ "${COMMAND}" == "sign" ]]; then
198 DEFINE_string payload "" \
199 "Path to output the generated unsigned payload file."
200 DEFINE_string metadata_signature_file "" \
201 "The metatada signatures in the following format: \
202metadata_signature1:metadata_signature2[:...]"
203 DEFINE_string payload_signature_file "" \
204 "The payload signatures in the following format: \
205payload_signature1:payload_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700206 DEFINE_string metadata_size_file "" \
207 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700208fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800209if [[ "${COMMAND}" == "properties" ]]; then
210 DEFINE_string payload "" \
211 "Path to the input signed or unsigned payload file."
212 DEFINE_string properties_file "-" \
213 "Path to output the extracted property files. If '-' is passed stdout will \
214be used."
215fi
Tudor Brindusb432db82018-06-29 13:13:27 -0700216if [[ "${COMMAND}" == "verify" || "${COMMAND}" == "check" ]]; then
Amin Hassani13520932017-07-26 11:26:05 -0700217 DEFINE_string payload "" \
218 "Path to the input payload file."
219 DEFINE_string target_image "" \
220 "Path to the target image to verify upon."
221 DEFINE_string source_image "" \
222 "Optional: Path to a source image. If specified, the delta update is \
223applied to this."
224fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800225
Alex Deymo5fbb1102017-01-12 13:55:52 -0800226DEFINE_string work_dir "${TMPDIR:-/tmp}" "Where to dump temporary files."
Jason Kusumabe998f42015-09-03 15:53:13 -0700227
228# Parse command line flag arguments
229FLAGS "$@" || exit 1
230eval set -- "${FLAGS_ARGV}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700231set -e
Jason Kusumabe998f42015-09-03 15:53:13 -0700232
Alex Deymo5fbb1102017-01-12 13:55:52 -0800233# Override the TMPDIR with the passed work_dir flags, which anyway defaults to
234# ${TMPDIR}.
235TMPDIR="${FLAGS_work_dir}"
236export TMPDIR
237
Alex Deymo89ff9e32015-09-15 19:29:01 -0700238# Associative arrays from partition name to file in the source and target
239# images. The size of the updated area must be the size of the file.
240declare -A SRC_PARTITIONS
241declare -A DST_PARTITIONS
242
Alex Deymo20bdc702016-12-07 21:07:11 -0800243# Associative arrays for the .map files associated with each src/dst partition
244# file in SRC_PARTITIONS and DST_PARTITIONS.
245declare -A SRC_PARTITIONS_MAP
246declare -A DST_PARTITIONS_MAP
247
Sen Jiang788c2d92016-03-09 12:48:40 -0800248# List of partition names in order.
249declare -a PARTITIONS_ORDER
250
Alex Deymo89ff9e32015-09-15 19:29:01 -0700251# A list of temporary files to remove during cleanup.
252CLEANUP_FILES=()
253
Alex Deymo48b502a2015-09-17 19:00:18 -0700254# Global options to force the version of the payload.
255FORCE_MAJOR_VERSION=""
256FORCE_MINOR_VERSION=""
257
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800258# Path to the postinstall config file in target image if exists.
259POSTINSTALL_CONFIG_FILE=""
260
Yifan Hong398cb542018-10-18 11:29:40 -0700261# Path to the dynamic partition info file in target image if exists.
262DYNAMIC_PARTITION_INFO_FILE=""
263
Alex Deymoc97df432015-09-25 17:23:52 -0700264# read_option_int <file.txt> <option_key> [default_value]
265#
266# Reads the unsigned integer value associated with |option_key| in a key=value
267# file |file.txt|. Prints the read value if found and valid, otherwise prints
268# the |default_value|.
269read_option_uint() {
270 local file_txt="$1"
271 local option_key="$2"
272 local default_value="${3:-}"
273 local value
274 if value=$(look "${option_key}=" "${file_txt}" | tail -n 1); then
275 if value=$(echo "${value}" | cut -f 2- -d "=" | grep -E "^[0-9]+$"); then
276 echo "${value}"
277 return
278 fi
279 fi
280 echo "${default_value}"
281}
282
Sen Jiangd0e9a892016-07-22 16:28:07 -0700283# truncate_file <file_path> <file_size>
284#
Dan Willemsen32711862018-10-04 21:25:50 -0700285# Truncate the given |file_path| to |file_size| using python.
Sen Jiangd0e9a892016-07-22 16:28:07 -0700286# The truncate binary might not be available.
287truncate_file() {
288 local file_path="$1"
289 local file_size="$2"
Dan Willemsen32711862018-10-04 21:25:50 -0700290 python -c "open(\"${file_path}\", 'a').truncate(${file_size})"
Sen Jiangd0e9a892016-07-22 16:28:07 -0700291}
292
Alex Deymo89ff9e32015-09-15 19:29:01 -0700293# Create a temporary file in the work_dir with an optional pattern name.
294# Prints the name of the newly created file.
295create_tempfile() {
296 local pattern="${1:-tempfile.XXXXXX}"
297 mktemp --tmpdir="${FLAGS_work_dir}" "${pattern}"
298}
Jason Kusumabe998f42015-09-03 15:53:13 -0700299
300cleanup() {
301 local err=""
Alex Deymo89ff9e32015-09-15 19:29:01 -0700302 rm -f "${CLEANUP_FILES[@]}" || err=1
Jason Kusumabe998f42015-09-03 15:53:13 -0700303
304 # If we are cleaning up after an error, or if we got an error during
305 # cleanup (even if we eventually succeeded) return a non-zero exit
306 # code. This triggers additional logging in most environments that call
307 # this script.
308 if [[ -n "${err}" ]]; then
309 die "Cleanup encountered an error."
310 fi
311}
312
313cleanup_on_error() {
314 trap - INT TERM ERR EXIT
315 cleanup
316 die "Cleanup success after an error."
317}
318
319cleanup_on_exit() {
320 trap - INT TERM ERR EXIT
321 cleanup
322}
323
324trap cleanup_on_error INT TERM ERR
325trap cleanup_on_exit EXIT
326
Alex Deymo48b502a2015-09-17 19:00:18 -0700327
Sen Jiang788c2d92016-03-09 12:48:40 -0800328# extract_image <image> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700329#
330# Detect the format of the |image| file and extract its updatable partitions
331# into new temporary files. Add the list of partition names and its files to the
Sen Jiang788c2d92016-03-09 12:48:40 -0800332# associative array passed in |partitions_array|. If |partitions_order| is
333# passed, set it to list of partition names in order.
Alex Deymo48b502a2015-09-17 19:00:18 -0700334extract_image() {
335 local image="$1"
336
337 # Brillo images are zip files. We detect the 4-byte magic header of the zip
338 # file.
Elliott Hughes5df503c2018-11-27 16:57:34 -0800339 local magic=$(xxd -p -l4 "${image}")
Alex Deymo48b502a2015-09-17 19:00:18 -0700340 if [[ "${magic}" == "504b0304" ]]; then
341 echo "Detected .zip file, extracting Brillo image."
342 extract_image_brillo "$@"
343 return
344 fi
345
346 # Chrome OS images are GPT partitioned disks. We should have the cgpt binary
347 # bundled here and we will use it to extract the partitions, so the GPT
348 # headers must be valid.
349 if cgpt show -q -n "${image}" >/dev/null; then
350 echo "Detected GPT image, extracting Chrome OS image."
351 extract_image_cros "$@"
352 return
353 fi
354
355 die "Couldn't detect the image format of ${image}"
356}
357
Sen Jiang788c2d92016-03-09 12:48:40 -0800358# extract_image_cros <image.bin> <partitions_array> [partitions_order]
Alex Deymo89ff9e32015-09-15 19:29:01 -0700359#
Alex Deymo48b502a2015-09-17 19:00:18 -0700360# Extract Chromium OS recovery images into new temporary files.
Alex Deymo89ff9e32015-09-15 19:29:01 -0700361extract_image_cros() {
362 local image="$1"
363 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800364 local partitions_order="${3:-}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700365
366 local kernel root
367 kernel=$(create_tempfile "kernel.bin.XXXXXX")
368 CLEANUP_FILES+=("${kernel}")
369 root=$(create_tempfile "root.bin.XXXXXX")
370 CLEANUP_FILES+=("${root}")
371
372 cros_generate_update_payload --extract \
373 --image "${image}" \
374 --kern_path "${kernel}" --root_path "${root}" \
375 --work_dir "${FLAGS_work_dir}" --outside_chroot
376
Alex Deymo83f2f702015-10-14 14:49:33 -0700377 # Chrome OS uses major_version 1 payloads for all versions, even if the
378 # updater supports a newer major version.
379 FORCE_MAJOR_VERSION="1"
380
Tudor Brindusdda79e22018-06-28 18:03:21 -0700381 eval ${partitions_array}[kernel]=\""${kernel}"\"
382 eval ${partitions_array}[root]=\""${root}"\"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700383
Sen Jiang788c2d92016-03-09 12:48:40 -0800384 if [[ -n "${partitions_order}" ]]; then
Tudor Brindusdda79e22018-06-28 18:03:21 -0700385 eval "${partitions_order}=( \"root\" \"kernel\" )"
Sen Jiang788c2d92016-03-09 12:48:40 -0800386 fi
387
Alex Deymo89ff9e32015-09-15 19:29:01 -0700388 local part varname
Tudor Brindusdda79e22018-06-28 18:03:21 -0700389 for part in kernel root; do
Alex Deymo89ff9e32015-09-15 19:29:01 -0700390 varname="${partitions_array}[${part}]"
391 printf "md5sum of %s: " "${varname}"
392 md5sum "${!varname}"
393 done
394}
395
Sen Jiang3e5804d2018-09-06 15:53:00 -0700396# extract_partition_brillo <target_files.zip> <partitions_array> <partition>
397# <part_file> <part_map_file>
398#
399# Extract the <partition> from target_files zip file into <part_file> and its
400# map file into <part_map_file>.
401extract_partition_brillo() {
402 local image="$1"
403 local partitions_array="$2"
404 local part="$3"
405 local part_file="$4"
406 local part_map_file="$5"
407
408 # For each partition, we in turn look for its image file under IMAGES/ and
409 # RADIO/ in the given target_files zip file.
410 local path path_in_zip
411 for path in IMAGES RADIO; do
412 if unzip -l "${image}" "${path}/${part}.img" >/dev/null; then
413 path_in_zip="${path}"
414 break
415 fi
416 done
417 [[ -n "${path_in_zip}" ]] || die "Failed to find ${part}.img"
418 unzip -p "${image}" "${path_in_zip}/${part}.img" >"${part_file}"
419
420 # If the partition is stored as an Android sparse image file, we need to
421 # convert them to a raw image for the update.
Yifan Hong4b821d72018-12-07 17:26:04 -0800422 local magic=$(xxd -p -l4 "${part_file}")
Sen Jiang3e5804d2018-09-06 15:53:00 -0700423 if [[ "${magic}" == "3aff26ed" ]]; then
424 local temp_sparse=$(create_tempfile "${part}.sparse.XXXXXX")
425 echo "Converting Android sparse image ${part}.img to RAW."
426 mv "${part_file}" "${temp_sparse}"
427 simg2img "${temp_sparse}" "${part_file}"
428 rm -f "${temp_sparse}"
429 fi
430
431 # Extract the .map file (if one is available).
432 unzip -p "${image}" "${path_in_zip}/${part}.map" >"${part_map_file}" \
433 2>/dev/null || true
434
435 # delta_generator only supports images multiple of 4 KiB. For target images
436 # we pad the data with zeros if needed, but for source images we truncate
437 # down the data since the last block of the old image could be padded on
438 # disk with unknown data.
439 local filesize=$(stat -c%s "${part_file}")
440 if [[ $(( filesize % 4096 )) -ne 0 ]]; then
441 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
442 echo "Rounding DOWN partition ${part}.img to a multiple of 4 KiB."
443 : $(( filesize = filesize & -4096 ))
444 else
445 echo "Rounding UP partition ${part}.img to a multiple of 4 KiB."
446 : $(( filesize = (filesize + 4095) & -4096 ))
447 fi
448 truncate_file "${part_file}" "${filesize}"
449 fi
450
451 echo "Extracted ${partitions_array}[${part}]: ${filesize} bytes"
452}
453
Sen Jiang788c2d92016-03-09 12:48:40 -0800454# extract_image_brillo <target_files.zip> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700455#
456# Extract the A/B updated partitions from a Brillo target_files zip file into
457# new temporary files.
458extract_image_brillo() {
459 local image="$1"
460 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800461 local partitions_order="${3:-}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700462
Alex Deymo48b502a2015-09-17 19:00:18 -0700463 local partitions=( "boot" "system" )
Alex Deymo168b5352015-11-04 13:51:52 -0800464 local ab_partitions_list
465 ab_partitions_list=$(create_tempfile "ab_partitions_list.XXXXXX")
466 CLEANUP_FILES+=("${ab_partitions_list}")
467 if unzip -p "${image}" "META/ab_partitions.txt" >"${ab_partitions_list}"; then
468 if grep -v -E '^[a-zA-Z0-9_-]*$' "${ab_partitions_list}" >&2; then
469 die "Invalid partition names found in the partition list."
470 fi
Sen Jiang34c711a2017-10-25 17:25:21 -0700471 # Get partition list without duplicates.
472 partitions=($(awk '!seen[$0]++' "${ab_partitions_list}"))
Alex Deymo168b5352015-11-04 13:51:52 -0800473 if [[ ${#partitions[@]} -eq 0 ]]; then
474 die "The list of partitions is empty. Can't generate a payload."
475 fi
476 else
477 warn "No ab_partitions.txt found. Using default."
478 fi
Sen Jiang3e5804d2018-09-06 15:53:00 -0700479 echo "List of A/B partitions for ${partitions_array}: ${partitions[@]}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700480
Sen Jiang788c2d92016-03-09 12:48:40 -0800481 if [[ -n "${partitions_order}" ]]; then
482 eval "${partitions_order}=(${partitions[@]})"
483 fi
484
Alex Deymo83f2f702015-10-14 14:49:33 -0700485 # All Brillo updaters support major version 2.
486 FORCE_MAJOR_VERSION="2"
487
Alex Deymo48b502a2015-09-17 19:00:18 -0700488 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800489 # Source image
490 local ue_config=$(create_tempfile "ue_config.XXXXXX")
Alex Deymoc97df432015-09-25 17:23:52 -0700491 CLEANUP_FILES+=("${ue_config}")
492 if ! unzip -p "${image}" "META/update_engine_config.txt" \
493 >"${ue_config}"; then
494 warn "No update_engine_config.txt found. Assuming pre-release image, \
495using payload minor version 2"
496 fi
Alex Deymo83f2f702015-10-14 14:49:33 -0700497 # For delta payloads, we use the major and minor version supported by the
498 # old updater.
Alex Deymoc97df432015-09-25 17:23:52 -0700499 FORCE_MINOR_VERSION=$(read_option_uint "${ue_config}" \
500 "PAYLOAD_MINOR_VERSION" 2)
Alex Deymo83f2f702015-10-14 14:49:33 -0700501 FORCE_MAJOR_VERSION=$(read_option_uint "${ue_config}" \
502 "PAYLOAD_MAJOR_VERSION" 2)
Alex Deymo61e1fa82016-01-19 15:16:34 -0800503
504 # Brillo support for deltas started with minor version 3.
505 if [[ "${FORCE_MINOR_VERSION}" -le 2 ]]; then
506 warn "No delta support from minor version ${FORCE_MINOR_VERSION}. \
507Disabling deltas for this source version."
508 exit ${EX_UNSUPPORTED_DELTA}
509 fi
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800510 else
511 # Target image
512 local postinstall_config=$(create_tempfile "postinstall_config.XXXXXX")
513 CLEANUP_FILES+=("${postinstall_config}")
514 if unzip -p "${image}" "META/postinstall_config.txt" \
515 >"${postinstall_config}"; then
516 POSTINSTALL_CONFIG_FILE="${postinstall_config}"
517 fi
Yifan Hong398cb542018-10-18 11:29:40 -0700518 local dynamic_partitions_info=$(create_tempfile "dynamic_partitions_info.XXXXXX")
519 CLEANUP_FILES+=("${dynamic_partitions_info}")
520 if unzip -p "${image}" "META/dynamic_partitions_info.txt" \
521 >"${dynamic_partitions_info}"; then
522 DYNAMIC_PARTITION_INFO_FILE="${dynamic_partitions_info}"
523 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700524 fi
525
Sen Jiang3e5804d2018-09-06 15:53:00 -0700526 local part
Alex Deymo48b502a2015-09-17 19:00:18 -0700527 for part in "${partitions[@]}"; do
Sen Jiang3e5804d2018-09-06 15:53:00 -0700528 local part_file=$(create_tempfile "${part}.img.XXXXXX")
529 local part_map_file=$(create_tempfile "${part}.map.XXXXXX")
530 CLEANUP_FILES+=("${part_file}" "${part_map_file}")
531 # Extract partitions in background.
532 extract_partition_brillo "${image}" "${partitions_array}" "${part}" \
533 "${part_file}" "${part_map_file}" &
Alex Deymo48b502a2015-09-17 19:00:18 -0700534 eval "${partitions_array}[\"${part}\"]=\"${part_file}\""
Alex Deymo20bdc702016-12-07 21:07:11 -0800535 eval "${partitions_array}_MAP[\"${part}\"]=\"${part_map_file}\""
Sen Jiang3e5804d2018-09-06 15:53:00 -0700536 done
537}
538
539# cleanup_partition_array <partitions_array>
540#
541# Remove all empty files in <partitions_array>.
542cleanup_partition_array() {
543 local partitions_array="$1"
544 # Have to use eval to iterate over associative array keys with variable array
545 # names, we should change it to use nameref once bash 4.3 is available
546 # everywhere.
547 for part in $(eval "echo \${!${partitions_array}[@]}"); do
548 local path="${partitions_array}[$part]"
549 if [[ ! -s "${!path}" ]]; then
550 eval "unset ${partitions_array}[${part}]"
551 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700552 done
553}
554
Tudor Brindusb432db82018-06-29 13:13:27 -0700555extract_payload_images() {
556 local payload_type=$1
557 echo "Extracting images for ${payload_type} update."
558
559 if [[ "${payload_type}" == "delta" ]]; then
560 extract_image "${FLAGS_source_image}" SRC_PARTITIONS
561 fi
562 extract_image "${FLAGS_target_image}" DST_PARTITIONS PARTITIONS_ORDER
Sen Jiang3e5804d2018-09-06 15:53:00 -0700563 # Wait for all subprocesses.
564 wait
565 cleanup_partition_array SRC_PARTITIONS
566 cleanup_partition_array SRC_PARTITIONS_MAP
567 cleanup_partition_array DST_PARTITIONS
568 cleanup_partition_array DST_PARTITIONS_MAP
Tudor Brindusb432db82018-06-29 13:13:27 -0700569}
570
571get_payload_type() {
572 if [[ -z "${FLAGS_source_image}" ]]; then
573 echo "full"
574 else
575 echo "delta"
576 fi
577}
578
Jason Kusumabe998f42015-09-03 15:53:13 -0700579validate_generate() {
580 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700581 die "You must specify an output filename with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700582
583 [[ -n "${FLAGS_target_image}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700584 die "You must specify a target image with --target_image FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700585}
586
587cmd_generate() {
Sen Jiang3e5804d2018-09-06 15:53:00 -0700588 local payload_type=$(get_payload_type)
589 extract_payload_images ${payload_type}
Jason Kusumabe998f42015-09-03 15:53:13 -0700590
Alex Deymo48b502a2015-09-17 19:00:18 -0700591 echo "Generating ${payload_type} update."
Alex Deymo168b5352015-11-04 13:51:52 -0800592 # Common payload args:
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700593 GENERATOR_ARGS=( --out_file="${FLAGS_payload}" )
Alex Deymo168b5352015-11-04 13:51:52 -0800594
595 local part old_partitions="" new_partitions="" partition_names=""
Alex Deymo20bdc702016-12-07 21:07:11 -0800596 local old_mapfiles="" new_mapfiles=""
Sen Jiang788c2d92016-03-09 12:48:40 -0800597 for part in "${PARTITIONS_ORDER[@]}"; do
Alex Deymo168b5352015-11-04 13:51:52 -0800598 if [[ -n "${partition_names}" ]]; then
599 partition_names+=":"
600 new_partitions+=":"
601 old_partitions+=":"
Alex Deymo20bdc702016-12-07 21:07:11 -0800602 new_mapfiles+=":"
603 old_mapfiles+=":"
Alex Deymo168b5352015-11-04 13:51:52 -0800604 fi
605 partition_names+="${part}"
606 new_partitions+="${DST_PARTITIONS[${part}]}"
607 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800608 new_mapfiles+="${DST_PARTITIONS_MAP[${part}]:-}"
609 old_mapfiles+="${SRC_PARTITIONS_MAP[${part}]:-}"
Alex Deymo168b5352015-11-04 13:51:52 -0800610 done
611
612 # Target image args:
613 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700614 --partition_names="${partition_names}"
615 --new_partitions="${new_partitions}"
616 --new_mapfiles="${new_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700617 )
618
Alex Deymo89ff9e32015-09-15 19:29:01 -0700619 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo168b5352015-11-04 13:51:52 -0800620 # Source image args:
Jason Kusumabe998f42015-09-03 15:53:13 -0700621 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700622 --old_partitions="${old_partitions}"
623 --old_mapfiles="${old_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700624 )
Alex Deymo48b502a2015-09-17 19:00:18 -0700625 if [[ -n "${FORCE_MINOR_VERSION}" ]]; then
626 GENERATOR_ARGS+=( --minor_version="${FORCE_MINOR_VERSION}" )
627 fi
628 fi
629
630 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
631 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
Jason Kusumabe998f42015-09-03 15:53:13 -0700632 fi
633
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700634 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
635 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
636 fi
637
Sen Jiang8e768e92017-06-28 17:13:19 -0700638 if [[ -n "${FLAGS_max_timestamp}" ]]; then
639 GENERATOR_ARGS+=( --max_timestamp="${FLAGS_max_timestamp}" )
640 fi
641
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800642 if [[ -n "${POSTINSTALL_CONFIG_FILE}" ]]; then
643 GENERATOR_ARGS+=(
644 --new_postinstall_config_file="${POSTINSTALL_CONFIG_FILE}"
645 )
646 fi
647
Yifan Hong398cb542018-10-18 11:29:40 -0700648 if [[ -n "{DYNAMIC_PARTITION_INFO_FILE}" ]]; then
649 GENERATOR_ARGS+=(
650 --dynamic_partition_info_file="${DYNAMIC_PARTITION_INFO_FILE}"
651 )
652 fi
653
Jason Kusumabe998f42015-09-03 15:53:13 -0700654 echo "Running delta_generator with args: ${GENERATOR_ARGS[@]}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700655 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700656
Alex Deymo89ff9e32015-09-15 19:29:01 -0700657 echo "Done generating ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700658}
659
660validate_hash() {
661 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700662 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700663
664 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700665 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700666--unsigned_payload FILENAME"
667
Jason Kusumabe998f42015-09-03 15:53:13 -0700668 [[ -n "${FLAGS_payload_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700669 die "You must specify --payload_hash_file FILENAME"
Jason Kusumaf514c542015-11-05 18:43:45 -0800670
671 [[ -n "${FLAGS_metadata_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700672 die "You must specify --metadata_hash_file FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700673}
674
675cmd_hash() {
Sen Jiangbf1266f2015-10-26 11:29:24 -0700676 "${GENERATOR}" \
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700677 --in_file="${FLAGS_unsigned_payload}" \
678 --signature_size="${FLAGS_signature_size}" \
679 --out_hash_file="${FLAGS_payload_hash_file}" \
680 --out_metadata_hash_file="${FLAGS_metadata_hash_file}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700681
Jason Kusumabe998f42015-09-03 15:53:13 -0700682 echo "Done generating hash."
683}
684
685validate_sign() {
686 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700687 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700688
689 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700690 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700691--unsigned_payload FILENAME"
692
693 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700694 die "You must specify the output signed payload with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700695
696 [[ -n "${FLAGS_payload_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700697 die "You must specify the payload signature file with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700698--payload_signature_file SIGNATURES"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700699
700 [[ -n "${FLAGS_metadata_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700701 die "You must specify the metadata signature file with \
Alex Deymo89ff9e32015-09-15 19:29:01 -0700702--metadata_signature_file SIGNATURES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700703}
704
705cmd_sign() {
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700706 GENERATOR_ARGS=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700707 --in_file="${FLAGS_unsigned_payload}"
708 --signature_size="${FLAGS_signature_size}"
709 --payload_signature_file="${FLAGS_payload_signature_file}"
710 --metadata_signature_file="${FLAGS_metadata_signature_file}"
711 --out_file="${FLAGS_payload}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700712 )
713
714 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
715 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
716 fi
717
718 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700719 echo "Done signing payload."
720}
721
Alex Deymo98e691c2016-02-04 21:05:45 -0800722validate_properties() {
723 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700724 die "You must specify the payload file with --payload FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800725
726 [[ -n "${FLAGS_properties_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700727 die "You must specify a non empty --properties_file FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800728}
729
730cmd_properties() {
731 "${GENERATOR}" \
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700732 --in_file="${FLAGS_payload}" \
733 --properties_file="${FLAGS_properties_file}"
Alex Deymo98e691c2016-02-04 21:05:45 -0800734}
735
Tudor Brindusb432db82018-06-29 13:13:27 -0700736validate_verify_and_check() {
Amin Hassani13520932017-07-26 11:26:05 -0700737 [[ -n "${FLAGS_payload}" ]] ||
738 die "Error: you must specify an input filename with --payload FILENAME"
739
740 [[ -n "${FLAGS_target_image}" ]] ||
741 die "Error: you must specify a target image with --target_image FILENAME"
742}
743
744cmd_verify() {
Tudor Brindusb432db82018-06-29 13:13:27 -0700745 local payload_type=$(get_payload_type)
746 extract_payload_images ${payload_type}
Amin Hassani13520932017-07-26 11:26:05 -0700747
748 declare -A TMP_PARTITIONS
749 for part in "${PARTITIONS_ORDER[@]}"; do
750 local tmp_part=$(create_tempfile "tmp_part.bin.XXXXXX")
751 echo "Creating temporary target partition ${tmp_part} for ${part}"
752 CLEANUP_FILES+=("${tmp_part}")
753 TMP_PARTITIONS[${part}]=${tmp_part}
754 local FILESIZE=$(stat -c%s "${DST_PARTITIONS[${part}]}")
755 echo "Truncating ${TMP_PARTITIONS[${part}]} to ${FILESIZE}"
756 truncate_file "${TMP_PARTITIONS[${part}]}" "${FILESIZE}"
757 done
758
759 echo "Verifying ${payload_type} update."
760 # Common payload args:
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700761 GENERATOR_ARGS=( --in_file="${FLAGS_payload}" )
Amin Hassani13520932017-07-26 11:26:05 -0700762
763 local part old_partitions="" new_partitions="" partition_names=""
764 for part in "${PARTITIONS_ORDER[@]}"; do
765 if [[ -n "${partition_names}" ]]; then
766 partition_names+=":"
767 new_partitions+=":"
768 old_partitions+=":"
769 fi
770 partition_names+="${part}"
771 new_partitions+="${TMP_PARTITIONS[${part}]}"
772 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
773 done
774
775 # Target image args:
776 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700777 --partition_names="${partition_names}"
778 --new_partitions="${new_partitions}"
Amin Hassani13520932017-07-26 11:26:05 -0700779 )
780
781 if [[ "${payload_type}" == "delta" ]]; then
782 # Source image args:
783 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700784 --old_partitions="${old_partitions}"
Amin Hassani13520932017-07-26 11:26:05 -0700785 )
786 fi
787
Amin Hassania566cb62017-08-23 12:36:55 -0700788 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
789 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
790 fi
791
Amin Hassani13520932017-07-26 11:26:05 -0700792 echo "Running delta_generator to verify ${payload_type} payload with args: \
793${GENERATOR_ARGS[@]}"
Sen Jiang6feb15c2018-08-31 15:45:17 -0700794 "${GENERATOR}" "${GENERATOR_ARGS[@]}" || true
Amin Hassani13520932017-07-26 11:26:05 -0700795
Sen Jiang6feb15c2018-08-31 15:45:17 -0700796 echo "Done applying ${payload_type} update."
797 echo "Checking the newly generated partitions against the target partitions"
798 local need_pause=false
799 for part in "${PARTITIONS_ORDER[@]}"; do
800 local not_str=""
801 if ! cmp "${TMP_PARTITIONS[${part}]}" "${DST_PARTITIONS[${part}]}"; then
802 not_str="in"
803 need_pause=true
804 fi
805 echo "The new partition (${part}) is ${not_str}valid."
806 done
807 # All images will be cleaned up when script exits, pause here to give a chance
808 # to inspect the images.
809 if [[ "$need_pause" == true ]]; then
810 read -n1 -r -s -p "Paused to investigate invalid partitions, \
811press any key to exit."
Amin Hassani13520932017-07-26 11:26:05 -0700812 fi
813}
814
Tudor Brindusb432db82018-06-29 13:13:27 -0700815cmd_check() {
816 local payload_type=$(get_payload_type)
817 extract_payload_images ${payload_type}
818
819 local part dst_partitions="" src_partitions=""
820 for part in "${PARTITIONS_ORDER[@]}"; do
821 if [[ -n "${dst_partitions}" ]]; then
822 dst_partitions+=" "
823 src_partitions+=" "
824 fi
825 dst_partitions+="${DST_PARTITIONS[${part}]}"
826 src_partitions+="${SRC_PARTITIONS[${part}]:-}"
827 done
828
829 # Common payload args:
830 PAYCHECK_ARGS=( "${FLAGS_payload}" --type ${payload_type} \
831 --part_names ${PARTITIONS_ORDER[@]} \
832 --dst_part_paths ${dst_partitions} )
833
834 if [[ ! -z "${SRC_PARTITIONS[@]}" ]]; then
835 PAYCHECK_ARGS+=( --src_part_paths ${src_partitions} )
836 fi
837
838 echo "Checking ${payload_type} update."
839 check_update_payload ${PAYCHECK_ARGS[@]} --check
840}
841
Jason Kusumabe998f42015-09-03 15:53:13 -0700842# Sanity check that the real generator exists:
Sen Jiang13519752016-08-02 16:10:52 -0700843GENERATOR="$(which delta_generator || true)"
Jason Kusumabe998f42015-09-03 15:53:13 -0700844[[ -x "${GENERATOR}" ]] || die "can't find delta_generator"
845
846case "$COMMAND" in
847 generate) validate_generate
848 cmd_generate
849 ;;
850 hash) validate_hash
851 cmd_hash
852 ;;
853 sign) validate_sign
854 cmd_sign
855 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800856 properties) validate_properties
857 cmd_properties
858 ;;
Tudor Brindusb432db82018-06-29 13:13:27 -0700859 verify) validate_verify_and_check
Amin Hassani13520932017-07-26 11:26:05 -0700860 cmd_verify
861 ;;
Tudor Brindusb432db82018-06-29 13:13:27 -0700862 check) validate_verify_and_check
863 cmd_check
864 ;;
Jason Kusumabe998f42015-09-03 15:53:13 -0700865esac